#!/usr/bin/python

import sys, os, os.path

def process_dir(prepath, directory):
	setname = os.path.basename(directory)

	print('    <set name="' + setname + '" description="' + setname + ' unit tests" feature="libnice">')
	print('')

	directories = []
	dirpath = prepath + "/" + directory

	for case_name in os.listdir(dirpath):
		casepath = dirpath + "/" + case_name
		if not os.path.isfile(casepath) \
		       or not os.access(casepath, os.X_OK):
			continue
		print('      <case name="' + case_name + '" level="Component" type="Functional" description="test ' + case_name + '">')
		print('        <step expected_result="0">/' + directory + '/' + case_name + '</step>')
		print('      </case>')

	print('')
	print('      <environments>')
	print('        <hardware>true</hardware>')
	print('      </environments>')
	print('')
	print('    </set>')
	print('')

def main(args):

	#add header information
	print('<?xml version="1.0" encoding="ISO-8859-1"?>')
	print('<testdefinition version="0.1">')
	print('  <suite name="libnice-tests" domain="VoIP calls">')
	print('')

	for d in args[1:]:
		process_dir(args[0], d)
	print('  </suite>')
	print('</testdefinition>')


if __name__ == '__main__':
	main(sys.argv[1:])
	sys.exit(0)

